Public Class Hime
    '====================================================================
    '                       Header file for:
    '                       H I M E . d l l
    '          Huge Integer Math and Encryption library dll
    '                            V 2.05
    '                 (C) 2002-2008 DevOTechS
    '                 e-mail: support@devotechs.com
    '====================================================================


    'When calling 'hi_GetGlobalError', following bits might be set:
    Public Const hi_ErrBit_Div = &H1                      '1
    Public Const hi_ErrBit_ModInv = &H2                   '2
    Public Const hi_ErrBit_GenerateRSAKeys = &H4          '3
    Public Const hi_ErrBit_Sub = &H8                      '4
    Public Const hi_ErrBit_Encrypt_RSA = &H10             '5
    Public Const hi_ErrBit_Decrypt_RSA = &H20             '6
    Public Const hi_ErrBit_Encrypt_AES_CBC = &H40         '7
    Public Const hi_ErrBit_Decrypt_AES_CBC = &H80         '8
    Public Const hi_ErrBit_Encrypt_AES_ECB = &H100        '9
    Public Const hi_ErrBit_Decrypt_AES_ECB = &H200        '10
    Public Const hi_ErrBit_Encrypt_AES_1Block = &H400     '11
    Public Const hi_ErrBit_Decrypt_AES_1Block = &H800     '12
    Public Const hi_ErrBit_Base642Huge = &H1000           '13
    Public Const hi_ErrBit_DiffieHellman = &H2000         '14
    Public Const hi_ErrBit_ConcatByte = &H4000            '15
    Public Const hi_ErrBit_EnDecrypt_Arc4 = &H8000        '16
    Public Const hi_ErrBit_Rec_GetField = &H10000         '17
    Public Const hi_ErrBit_Rec_GetNrFields = &H20000      '18
    Public Const hi_ErrBit_RegAllocRange = &H40000        '19
    Public Const hi_ErrBit_CompDecompress = &H80000       '20
    Public Const hi_ErrBit_FileError = &H100000           '21
    Public Const hi_ErrBit_BitManipulation = &H200000     '22

    'Modify full path location of HIME.dll here:

    Declare Ansi Function HI_FACTOR_POLLARDS_RHO Lib "HIME.DLL" (ByRef lReg_N As Integer, ByRef lReg_x0 As Integer, ByRef lm As Integer, ByRef lReg_c As Integer, ByRef lReg_Command As Integer, ByRef lReg_Status As Integer, ByRef lReg_f As Integer) As Integer
    Declare Ansi Function HI_PUTREGDWORD Lib "HIME.DLL" (ByRef dData As Integer, ByRef lReg As Integer) As Integer

    Declare Ansi Function HI_ADD Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_AND Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_BASE642HUGE Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_BIN2HUGE Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_BITCLEAR Lib "HIME.DLL" (ByRef BITNR As Integer, ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_BITSET Lib "HIME.DLL" (ByRef BITNR As Integer, ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_BITTOGGLE Lib "HIME.DLL" (ByRef BITNR As Integer, ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_BREAKSTRING Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef CHARSINCHUNK As Integer, ByRef NROFSPACES As Integer, ByRef CHUNKSINLINE As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_CHECKTESTVECTORS_AES Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_CHECKTESTVECTORS_ARC4 Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_CHECKTESTVECTORS_MD5 Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_CHECKTESTVECTORS_SHA_1 Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_CHECKTESTVECTORS_SHA_256 Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_CHECKTESTVECTORS_SHA_512 Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_COMPRESS Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef ALGO As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_COPYREG Lib "HIME.DLL" (ByRef LREGSOURCE As Integer, ByRef LREGTARGET As Integer) As Integer
    Declare Ansi Function HI_DEC2HUGE Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_DECOMPRESS Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_DECR Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_DECRYPT_AES_1BLOCK Lib "HIME.DLL" (ByRef LREG_CIPHER As Integer, ByRef LREG_KEY As Integer, ByRef LREG_PLAIN As Integer) As Integer
    Declare Ansi Function HI_DECRYPT_AES_CBC Lib "HIME.DLL" (ByRef LREG_CIPHER As Integer, ByRef LREG_KEY As Integer, ByRef LREG_PLAIN As Integer) As Integer
    Declare Ansi Function HI_DECRYPT_AES_ECB Lib "HIME.DLL" (ByRef LREG_CIPHER As Integer, ByRef LREG_KEY As Integer, ByRef LREG_PLAIN As Integer) As Integer
    Declare Ansi Function HI_DECRYPT_ARC4 Lib "HIME.DLL" (ByRef LREG_CIPHER As Integer, ByRef LREG_KEY As Integer, ByRef LREG_PLAIN As Integer, ByRef BYTESTODISCARD As Integer) As Integer
    Declare Ansi Function HI_DECRYPT_RSA Lib "HIME.DLL" (ByRef LREG_CIPHER As Integer, ByRef LREG_HD As Integer, ByRef LREG_HMODUL As Integer, ByRef LREG_PLAIN As Integer) As Integer
    Declare Ansi Function HI_DECRYPT_RSA_CRT Lib "HIME.DLL" (ByRef LREG_CIPHER As Integer, ByRef LREG_P As Integer, ByRef LREG_Q As Integer, ByRef LREG_DP As Integer, ByRef LREG_DQ As Integer, ByRef LREG_PINVQ As Integer, ByRef LREG_PLAIN As Integer) As Integer
    Declare Ansi Function HI_DH_GENPARAMS Lib "HIME.DLL" (ByRef LBITLENGTH As Integer, ByRef LREGP As Integer, ByRef LREGG As Integer) As Integer
    Declare Ansi Function HI_DH_STEP1 Lib "HIME.DLL" (ByRef LREGP As Integer, ByRef LREGG As Integer, ByRef LPRIV As Integer, ByRef LPUB As Integer) As Integer
    Declare Ansi Function HI_DH_STEP2 Lib "HIME.DLL" (ByRef LREGP As Integer, ByRef LPUB As Integer, ByRef LPRIV As Integer, ByRef LSHARED As Integer) As Integer
    Declare Ansi Function HI_DIV Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_QUOT As Integer, ByRef LREG_REM As Integer) As Integer
    Declare Ansi Function HI_DIVBY2 Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_QUOT As Integer, ByRef LREG_REM As Integer) As Integer
    Declare Ansi Function HI_ENCRYPT_AES_1BLOCK Lib "HIME.DLL" (ByRef LREG_PLAIN As Integer, ByRef LREG_KEY As Integer, ByRef LREG_CIPHER As Integer) As Integer
    Declare Ansi Function HI_ENCRYPT_AES_CBC Lib "HIME.DLL" (ByRef LREG_PLAIN As Integer, ByRef LREG_KEY As Integer, ByRef LREG_IV As Integer, ByRef LREG_CIPHER As Integer) As Integer
    Declare Ansi Function HI_ENCRYPT_AES_ECB Lib "HIME.DLL" (ByRef LREG_PLAIN As Integer, ByRef LREG_KEY As Integer, ByRef LREG_CIPHER As Integer) As Integer
    Declare Ansi Function HI_ENCRYPT_ARC4 Lib "HIME.DLL" (ByRef LREG_PLAIN As Integer, ByRef LREG_KEY As Integer, ByRef LREG_CIPHER As Integer, ByRef BYTESTODISCARD As Integer) As Integer
    Declare Ansi Function HI_ENCRYPT_RSA Lib "HIME.DLL" (ByRef LREG_PLAIN As Integer, ByRef LREG_HE As Integer, ByRef LREG_HMODUL As Integer, ByRef LREG_CIPHER As Integer) As Integer
    Declare Ansi Function HI_EXTEUCLIDALGO Lib "HIME.DLL" (ByRef LREG_A As Integer, ByRef LREG_B As Integer, ByRef FORCEPOSITIVERESULTS As Integer, ByRef LREG_GCD As Integer, ByRef LREG_X As Integer, ByRef LREG_Y As Integer, ByRef SIGN_X As Integer, ByRef SIGN_Y As Integer) As Integer
    Declare Ansi Function HI_GCD Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_GENERATEBBSRANDOMBITS Lib "HIME.DLL" (ByRef LBYTES As Integer, ByRef LMULTIPLEBITS As Integer, ByRef LREG_SSEED As Integer, ByRef LREG_MODUL As Integer, ByRef LREG_RESULT As Integer, ByRef LREG_ESEED As Integer) As Integer
    Declare Ansi Function HI_GENERATEPRIME Lib "HIME.DLL" (ByRef LLENGTHBITS As Integer, ByRef LPRIMETESTS As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_GENERATERANDOM Lib "HIME.DLL" (ByRef LLENGTHBITS As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_GENERATERSAKEYS Lib "HIME.DLL" (ByRef LBITLENGTH As Integer, ByRef LPRIMETESTS As Integer, ByRef LREG_HE As Integer, ByRef LREG_HD As Integer, ByRef LREG_MODUL As Integer) As Integer
    Declare Ansi Function HI_GENERATERSAKEYS_CRT Lib "HIME.DLL" (ByRef LBITLENGTH As Integer, ByRef LPRIMETESTS As Integer, ByRef LREG_HE As Integer, ByRef LREG_MODUL As Integer, ByRef LREG_HP As Integer, ByRef LREG_HQ As Integer, ByRef LREG_HDP As Integer, ByRef LREG_HDQ As Integer, ByRef LREG_HPINVQ As Integer) As Integer
    Declare Ansi Function HI_GENERATERSARANDOMBITS Lib "HIME.DLL" (ByRef LBYTES As Integer, ByRef LREG_SSEED As Integer, ByRef LREG_HE As Integer, ByRef LREG_MODUL As Integer, ByRef LREG_RESULT As Integer, ByRef LREG_ENDSEED As Integer) As Integer
    Declare Ansi Function HI_GETGLOBALERROR Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_GETOPTION Lib "HIME.DLL" (ByRef LOPTION As Integer, ByRef LPARAM As Integer) As Integer
    Declare Ansi Function HI_GETRANDOMBYTESFROMSERVER Lib "HIME.DLL" (ByRef SERVER_ As Integer, ByRef PORT_ As Integer, ByRef COMMAND As Integer, ByRef TIMEOUT_ As Integer, ByRef NUMBERBYTES As Integer, ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_GETREG Lib "HIME.DLL" (ByRef LREG As Integer) As String
    Declare Ansi Function HI_GETREGADD Lib "HIME.DLL" (ByRef LREG As Integer, ByRef LADDRESS As Integer, ByRef LLEN As Integer) As Integer
    Declare Ansi Function HI_GETREGADD2 Lib "HIME.DLL" (ByRef LREG As Integer, ByRef LADDRESS As Integer) As Integer
    Declare Ansi Function HI_GETREGASCIIZ1 Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_GETREGASCIIZ2 Lib "HIME.DLL" (ByRef LREG As Integer, ByRef AZDATA As String) As Integer
    Declare Ansi Function HI_GETREGBYTE Lib "HIME.DLL" (ByRef LREG As Integer, ByRef INDEX As Integer) As Integer
    Declare Ansi Function HI_GETREGTOCLIPBOARD Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_GETREGTOFILE Lib "HIME.DLL" (ByRef LREG As Integer, ByRef MODE As Integer, ByRef LREG_FILENAME As Integer) As Integer
    Declare Ansi Function HI_HASH_CRC32 Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HASH_MD5 Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HASH_SHA_1 Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HASH_SHA_256 Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HASH_SHA_512 Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HEX2HUGE Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HUGE2BASE64 Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HUGE2BIN Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HUGE2DEC Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_HUGE2HEX Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_INCR Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_INITBBS Lib "HIME.DLL" (ByRef LBITLENGTH As Integer, ByRef LPRIMETESTS As Integer, ByRef LREG_MODUL As Integer, ByRef LREG_SEED As Integer) As Integer
    Declare Ansi Function HI_ISBITSET Lib "HIME.DLL" (ByRef BITNR As Integer, ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_ISEQUAL Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer) As Integer
    Declare Ansi Function HI_ISLESS Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer) As Integer
    Declare Ansi Function HI_ISNOTEQUAL Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer) As Integer
    Declare Ansi Function HI_ISODD Lib "HIME.DLL" (ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_ISPRIME_DIV Lib "HIME.DLL" (ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_ISPRIME_F Lib "HIME.DLL" (ByRef LTESTS As Integer, ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_ISPRIME_RB Lib "HIME.DLL" (ByRef LTESTS As Integer, ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_ISPRIME_SLOW Lib "HIME.DLL" (ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_ISREGALLOCATED Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_ISRELPRIME Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer) As Integer
    Declare Ansi Function HI_ISZERO Lib "HIME.DLL" (ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_MOD Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_MODINV Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_MUL Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_MULBY2 Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_NOT Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_OR Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_POW Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_POWMOD Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG3 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_PUTREG Lib "HIME.dll" (ByRef H As String, ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_PUTREGADD Lib "HIME.DLL" (ByRef LADDRESS As Integer, ByRef LLEN As Integer, ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_PUTREGASCIIZ Lib "HIME.DLL" (ByRef AZDATA As String, ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_PUTREGFROMCLIPBOARD Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_PUTREGFROMFILE Lib "HIME.DLL" (ByRef LREG_FILENAME As Integer, ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_READPRIMES Lib "HIME.DLL" (ByRef LPRIMESTOREAD As Integer) As Integer
    Declare Ansi Function HI_REC_ADDFIELD Lib "HIME.DLL" (ByRef FLD As Integer, ByRef REC As Integer) As Integer
    Declare Ansi Function HI_REC_GETFIELD Lib "HIME.DLL" (ByRef REC As Integer, ByRef INDEX As Integer, ByRef FLD As Integer) As Integer
    Declare Ansi Function HI_REC_GETNRFIELDS Lib "HIME.DLL" (ByRef REC As Integer) As Integer
    Declare Ansi Function HI_REGALLOCATE Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_REGALLOCATEMULTIPLE Lib "HIME.DLL" (ByRef LREGS As Integer) As Integer
    Declare Ansi Function HI_REGALLOCATERANGE Lib "HIME.DLL" (ByRef LFIRSTREG As Integer, ByRef LLASTREG As Integer) As Integer
    Declare Ansi Function HI_REGCHANGEENDIAN Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_REGCLEAR Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_REGCOMPARE Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer) As Integer
    Declare Ansi Function HI_REGCONCATBYTE Lib "HIME.DLL" (ByRef LREG As Integer, ByRef LVAL As Integer) As Integer
    Declare Ansi Function HI_REGCONCATREG Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG3 As Integer) As Integer
    Declare Ansi Function HI_REGGETLEN Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_REGISTER Lib "HIME.DLL" (ByRef LREG1 As Integer) As Integer
    Declare Ansi Function HI_REGMAXALLOCATED Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_REGREVERSE Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_REGSPLIT Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LBYTES As Integer, ByRef LREGL As Integer, ByRef LREGR As Integer) As Integer
    Declare Ansi Function HI_REGUNALLOCATE Lib "HIME.DLL" (ByRef LREG As Integer) As Integer
    Declare Ansi Function HI_REGUNALLOCATERANGE Lib "HIME.DLL" (ByRef LFIRSTREG As Integer, ByRef LLASTREG As Integer) As Integer
    Declare Ansi Function HI_REGWIPE Lib "HIME.DLL" (ByRef LREG As Integer, ByRef MODE As Integer, ByRef CLR As Integer) As Integer
    Declare Ansi Function HI_SETOPTION Lib "HIME.DLL" (ByRef LOPTION As Integer, ByRef LPARAM As Integer) As Integer
    Declare Ansi Function HI_SHREDFILE Lib "HIME.DLL" (ByRef LREG_FILENAME As Integer, ByRef FILEMODE As Integer, ByRef PASSES As Integer, ByRef ALGO As Integer, ByRef PARAMETER As Integer) As Integer
    Declare Ansi Function HI_SQUARE Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_STACKWIPE Lib "HIME.DLL" (ByRef STACKSIZE As Integer, ByRef CLEARANCE As Integer) As Integer
    Declare Ansi Function HI_SUB Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer
    Declare Ansi Function HI_SWAPREG Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer) As Integer
    Declare Ansi Function HI_TRIMLZEROES Lib "HIME.DLL" (ByRef LREGIN As Integer, ByRef LREGOUT As Integer) As Integer
    Declare Ansi Function HI_VERSION Lib "HIME.DLL" () As Integer
    Declare Ansi Function HI_XOR Lib "HIME.DLL" (ByRef LREG1 As Integer, ByRef LREG2 As Integer, ByRef LREG_RESULT As Integer) As Integer

End Class
